make/update-rules.sh

changeset 8
756b49205a29
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/make/update-rules.sh	Tue Nov 07 20:24:08 2023 +0100
@@ -0,0 +1,48 @@
+#!/bin/sh
+
+dir="$1"
+
+if [ -z "$dir" ]; then
+  echo "Usage: $0 <src_dir>"
+  exit 1
+fi
+
+if [ -d "$dir" ]; then
+  :
+else
+  echo "'$dir' is not a directory"
+  exit 1
+fi
+
+if [ -z "$CC" ]; then
+  for cc in gcc clang ; do
+    if command -v "$cc" > /dev/null ; then
+      CC="$cc"
+      break
+    fi
+  done
+fi
+
+if [ -z "$CC" ]; then
+  echo "No suitable compiler found to generate make rules"
+  exit 1
+fi
+
+if command -v sed > /dev/null ; then
+  :
+else
+  echo "You need the 'sed' program for this script to work."
+  exit 1
+fi
+
+cd "$dir"
+
+mv Makefile Makefile.old
+sed '/FORCE:/q' Makefile.old > Makefile
+echo >> Makefile
+for file in `ls *.c` ; do
+  "$CC" -MT "\$(BUILD_DIR)/${file/.c/.o}" -MM $CFLAGS "$file"
+  printf '\t@echo "Compiling $<"\n'
+  printf '\t$(CC) -o $@ $(CFLAGS) -c $<\n\n'
+done  >> Makefile
+rm Makefile.old

mercurial